function! oh_hai#hello() abort
  echo "💖 Oh, hai 💖"
endfunction

function! oh_hai#run(args) abort
  let args = map(
  \   a:args[:],
  \   { _, v -> shellescape(v) },
  \ )
  let output = system(join(args))
  return split(output, '\r\?\n')
endfunction

function! oh_hai#runner(args) abort
  let namespace = substitue(a:filetype, '\W', '_', 'g')
  let funcname = printf('oh_hai#runner#%s#new'), a:filetype)
  try
    return call(funcname, [])
  catch /:E117: [^:]\+: oh_hai#runner#[^#]\+#new/
    throw printf('oh_hai: Runner is not found: %s', a:filetype)
  endtry
endfunction
